//
// Object Oriented Programming Example: a Car object
//

Car myCar;

void setup() {
  size(200,200);
  // Parameters go inside the parentheses when the object is constructed.
  myCar = new Car(color(255,0,0),0,100,2); 

}

void draw() {
  background(255);
  myCar.drive();
  myCar.display();

}

// Even if we use multiple objects, we still only need one class. 
// No matter how many cookies we make, only one cookie cutter is needed.
class Car { 
  color c;
  float xpos;
  float ypos;
  float xspeed;

  // The Constructor is defined with arguments.
  Car(color tempC, float tempXpos, float tempYpos, float tempXspeed) { 
    c = tempC;
    xpos = tempXpos;
    ypos = tempYpos;
    xspeed = tempXspeed;
  }

  void display() {
    strokeWeight(3);
    stroke(0);
    fill(c);
    rectMode(CENTER);
    rect(xpos,ypos,20,10);
  }

  void drive() {
    xpos = xpos + xspeed;
    if (xpos > width) {
      xpos = 0;
    }
  }
}